#this import statement allows access to the karamba functions
import karamba
from datetime import date
from datetime import timedelta

monOffset = 0
textColor = 255, 255, 255

def fillKalenderTage(widget,prefix,anfang,ende):
    
    text = 0
    output = ""
    kwstart = anfang - timedelta(anfang.weekday())
    for index in range(1,7):
        if index > 1:
            kwstart = kwstart + timedelta(7)
        output = ""
        text = karamba.getThemeText(widget,prefix+repr(index))
        if kwstart <= ende:
            for wochentag in range(0,7):
                if wochentag > 0:
                    output = output + " "
                if kwstart + timedelta(wochentag) >= anfang:
                    if kwstart + timedelta(wochentag) <= ende:
                        output = output + '%2d' % (kwstart + timedelta(wochentag)).day
                else:
                    output = output + "  "
            karamba.changeText(widget,text,output)
        else:
            karamba.changeText(widget,text,"")

def fillKalenderWoche(widget,prefix,anfang,ende):
    
    text = 0
    kwstart = anfang - timedelta(anfang.weekday())
    for index in range(1,7):
        if index > 1:
            kwstart = kwstart + timedelta(7)
        text = karamba.getThemeText(widget,prefix+repr(index))
        if kwstart <= ende:
            karamba.changeText(widget,text,repr(kwstart.isocalendar()[1]))
        else:
            karamba.changeText(widget,text,"")

def fillMonatName(widget,name,datum):
    
    text = 0
    text = karamba.getThemeText(widget,name)
    karamba.changeText(widget,text,datum.strftime("%B %Y"))

def setHeute(widget,name,datum):
    
    image = karamba.getThemeImage(widget,name)
    if monOffset == 0:
        wochenoffset = datum.isocalendar()[1] - date(datum.year,datum.month,1).isocalendar()[1]
        karamba.showImage(widget,image)
        karamba.moveImage(widget,image,45+datum.weekday()*21,160+wochenoffset*17)
    else:
        karamba.hideImage(widget,image)

def Offset(datum,monOffset):
    
    print datum.year+(datum.month+monOffset-1)/12," Jahre, ",(datum.month+monOffset-1)%12+1," Monate"
    return date(datum.year+(datum.month+monOffset-1)/12,(datum.month+monOffset-1)%12+1,1)

def fillTextFields(widget):
    
    now = date.today()
    if monOffset != 0:
        now = Offset(now,monOffset)
    mitte_1 = date(now.year,now.month,15)
    anfang_1 = date(mitte_1.year,mitte_1.month,1)
    mitte_0 = mitte_1 - timedelta(30)
    anfang_0 = date(mitte_0.year,mitte_0.month,1)
    ende_0 = anfang_1 - timedelta(1)
    mitte_2 = mitte_1 + timedelta(30)
    anfang_2 = date(mitte_2.year,mitte_2.month,1)
    ende_1 = anfang_2 - timedelta(1)
    mitte_3 = mitte_2 + timedelta(30)
    anfang_3 = date(mitte_3.year,mitte_3.month,1)
    ende_2 = anfang_3 - timedelta(1)
    text = 0
    
    fillMonatName(widget,"monat_0",mitte_0)
    fillKalenderWoche(widget,"kw_0_",anfang_0,ende_0)
    fillKalenderTage(widget,"woche_0_",anfang_0,ende_0)
    
    fillMonatName(widget,"monat_1",mitte_1)
    fillKalenderWoche(widget,"kw_1_",anfang_1,ende_1)
    fillKalenderTage(widget,"woche_1_",anfang_1,ende_1)
    setHeute(widget,"heute",now)
    
    fillMonatName(widget,"monat_2",mitte_2)
    fillKalenderWoche(widget,"kw_2_",anfang_2,ende_2)
    fillKalenderTage(widget,"woche_2_",anfang_2,ende_2)


def setTextColor(widget,r,g,b):
    
    text = 0
    for monat in range(3):
        text = karamba.getThemeText(widget,"monat_"+repr(monat))
        karamba.changeTextColor(widget,text,r,g,b)
        for woche in range(1,7):
            text = karamba.getThemeText(widget,"kw_"+repr(monat)+"_"+repr(woche))
            karamba.changeTextColor(widget,text,r,g,b)
            text = karamba.getThemeText(widget,"woche_"+repr(monat)+"_"+repr(woche))
            karamba.changeTextColor(widget,text,r,g,b)

def readConfiguration(widget):
    global textColor

    try:
        r = int(karamba.readConfigEntry(widget, "textColor_r"))
        g = int(karamba.readConfigEntry(widget, "textColor_g"))
        b = int(karamba.readConfigEntry(widget, "textColor_b"))
        textColor = r, g, b
    except:
        print "Text color preference not found. Using default and writing new"
        writeConfiguration(widget)

def writeConfiguration(widget):
    global textColor
    r,g,b = textColor
    karamba.writeConfigEntry(widget, "textColor_r", str(r))
    karamba.writeConfigEntry(widget, "textColor_g", str(g))
    karamba.writeConfigEntry(widget, "textColor_b", str(b))

#this is called when your widget is initialized
def initWidget(widget):
    global btnRueckwaerts, btnHeute, btnVorwaerts, textHelligkeit, monOffset, textColor
    monOffset = 0
    readConfiguration(widget)
    r,g,b = textColor
    themepath = karamba.getThemePath(widget)
    picspath = themepath+'pics/';
    btnRueckwaerts = karamba.createImage(widget, 0, 10, picspath+"rueckwaerts.png");
    btnHeute = karamba.createImage(widget, 0, 360, picspath+"jetzt.png");
    btnVorwaerts = karamba.createImage(widget, 0, 380, picspath+"vorwaerts.png");
    textHelligkeit = karamba.createImage(widget, 175, 5, picspath+"texthelligkeit.png");
    karamba.attachClickArea(widget, btnRueckwaerts)
    karamba.attachClickArea(widget, btnHeute)
    karamba.attachClickArea(widget, btnVorwaerts)
    karamba.attachClickArea(widget, textHelligkeit)
    setTextColor(widget,r,g,b)
    fillTextFields(widget)
    karamba.redrawWidget(widget)

#This is called when your widget is closed.  You can use this to clean
#up open files, etc.  You don't need to delete text and images in your
#theme.  That is done automatically.  This callback is just for cleaning up
#external things.  Most people don't need to put anything here.
def widgetClosed(widget):
    pass

#this is called everytime your widget is updated
#the update inverval is specified in the .theme file
def widgetUpdated(widget):
    fillTextFields(widget)

#This gets called everytime our widget is clicked.
#Notes:
#  widget = reference to our widget
#  x = x position (relative to our widget)
#  y = y position (relative to our widget)
#  botton = button clicked:
#                    1 = Left Mouse Button
#                    2 = Middle Mouse Button
#                    3 = Right Mouse Button, but this will never happen
#                        because the right mouse button brings up the
#                        Karamba menu.
#                    4,5 = Scroll wheel up and down
def widgetClicked(widget, x, y, button):
    pass

#This gets called everytime our widget is clicked.
#Notes
#  widget = reference to our widget
#  x = x position (relative to our widget)
#  y = y position (relative to our widget)
#  botton = button being held:
#                    0 = No Mouse Button
#                    1 = Left Mouse Button
#                    2 = Middle Mouse Button
#                    3 = Right Mouse Button, but this will never happen
#                        because the right mouse button brings up the
#                        Karamba menu.
def widgetMouseMoved(widget, x, y, button):
    #Warning:  Don't do anything too intensive here
    #You don't want to run some complex piece of code everytime the mouse moves
    pass


#This gets called when an item is clicked in a popup menu you have created.
#  menu = a reference to the menu
#  id = the number of the item that was clicked.
def menuItemClicked(widget, menu, id):
    pass

#This gets called when an item is clicked in the theme CONFIGURATION menu,
#not the popup menus that you create.
#  key = the reference to the configuration key that was changed
#  value = the new value (true or false) that was selected
def menuOptionChanged(widget, key, value):
    pass

#This gets called when a meter (image, text, etc) is clicked.
# NOTE you must use attachClickArea() to make a meter
# clickable.  
#  widget = reference to your theme
#  meter = the meter clicked
#  button = the button clicked (see widgetClicked for button numbers)
def meterClicked(widget, meter, button):
    global monOffset, textColor
    redraw = 0
    if meter == btnRueckwaerts:
        monOffset = monOffset - 1
        print "zurueck!! (",monOffset,")"
        redraw = 1
        
    if meter == btnHeute and monOffset != 0:
        print "heute!!"
        monOffset = 0
        redraw = 1
        
    if meter == btnVorwaerts:
        monOffset = monOffset + 1
        print "vorwaerts!! (",monOffset,")"
        redraw = 1
        
    if meter == textHelligkeit:
        r,g,b = textColor
        r = (r + 32) % 256
        g = (g + 32) % 256
        b = (b + 32) % 256
        setTextColor(widget,r,g,b)
        textColor = r, g, b
        writeConfiguration(widget)
        redraw = 1
        
    if redraw:
        fillTextFields(widget)
        karamba.redrawWidget(widget)

#This gets called when a command you have executed with executeInteractive() outputs something
#to stdout.  This way you can get the output of for example kdialog without freezing up the widget
#waiting for kdialog to end.
#  widget = reference to your theme
#  pid = process number of the program outputting (use this if you execute more than out process)
#  output = the text the program outputted to stdout
def commandOutput(widget, pid, output):
    pass

#This gets called when another theme sends a message.
#  widget = reference to your theme
#  caller = "pretty" name or regular name (name of theme file with a number attached) of sending theme
#  output = the text sent.
def themeNotify(widget, caller, message):
    pass

#This gets called when an item is dropped on this widget.
# NOTE you have to call acceptDrops() before your widget will accept drops.
#  widget = reference to your theme
#  dropText = the text of the dropped item (probably a URL to it's location in KDE)
#  x = the x position on the theme relative to the upper left corner
#  y = the y position on the theme relative to the upper left corner
def itemDropped(widget, dropText, x, y):
    pass


#This gets called when a new program is LOADING in KDE.  When it is done
#loading, startupRemoved() is called, followed by taskAdded().
#  widget = reference to your widget
#  task = A refence to the task that is starting.  
def startupAdded(widget, startup):
    pass

#This gets called when a new program is done LOADING in KDE.
#  widget = reference to your widget
#  task = A refence to the task that just finished loading.  
def startupRemoved(widget, startup):
    pass

#This is called every time a new task (program) is started in KDE.
#  widget = reference to your widget
#  task = A refence to the new task.  Call getTaskInfo() with this reference
#         to get the name, etc of this new task.
def taskAdded(widget, task):
    pass

#This is called everytime a task (program) is closed in KDE.
#  widget = reference to your widget
#  task = A refence to the task.  
def taskRemoved(widget, task):
    pass

#This is called everytime a different task gains focus (IE, the user clicks
#on a different window).  
#  widget = reference to your widget
#  task = A refence to the task.  Call getTaskInfo() with this reference
#         to get the name, etc of this new task.
def activeTaskChanged(widget, task):
    pass

#This is called everytime the systray you created with createSystray() is updated
def systrayUpdated(widget):
    pass

#This is called everytime the current desktop changes
#  widget = reference to your widget
#  desktop = the current desktop
def desktopChanged(widget, desktop):
    pass

#This is called everytime the wallpaper changes on a desktop 
#  widget = reference to your widget
#  desktop = the desktop whose wallpaper changed
def wallpaperChanged(widget, desktop):
    pass

#This is called everytime there is a key press in any focused input field
#  widget = reference to your widget
#  meter = reference to an input box
#  char = the key that was pressed
def keyPressed(widget, meter, char):
    pass

# This will be printed when the widget loads.
print "Loaded my python extension!"
